#include "temporary.h"
#include "myrtos_task.h"
#include "myrtos_port.h"
#include "myrtos_func.h"
#include "myrtos.h"
#include "user_func.h"
#include "myrtos_sem.h"

//  
void sem_create(sem_param_init *sem,
								uint8_t val)
{
	reset_queue_sem(&(sem->sem_queue));
	sem->count = val;
	sem->max_count = val;
}

//  
//       == 0
//       -    
void sem_in(sem_param_init *sem)
{
	uint8_t priority;
	
	arm_disable_interrupts();
	
	//   
	if(sem->count > 0)
	{
		sem->count--;
	}
	//  
	else
	{
		//      
		//      
		queue_remove_task(&(curr_run_task->task_queue));
		queue_sem_add(curr_run_task, sem);
		
		//   .    
		priority = queue_find_priority_next_task();
		next_task_to_run = task_param_from_task_queue(task_queue_priority[priority].next);
		
		switch_context();		
		arm_enable_interrupts();
	}
	
	arm_enable_interrupts();
}

//   -   1 
void sem_out(sem_param_init *sem)
{
	task_param_init *next_task;
	
	arm_disable_interrupts();
	
	//     (     ) -  
	//     -  .     
	if((sem->sem_queue).next != &(sem->sem_queue))
	{
		//  . 
		next_task = task_param_from_task_queue((sem->sem_queue).next);
		
		//      .   ( )
		queue_remove_task(&(next_task->task_queue));
		queue_task_add(next_task);
	}
	else
	{
		sem->count++;
		// count      
		if(sem->count > sem->max_count)
		{
			sem->count = sem->max_count;
		}
	}
	
	arm_enable_interrupts();
}


